Attribute VB_Name = "modCopyInThread"
Option Explicit
                   
Public Const MAX_PATH                As Long = 260
Public Const DUPLICATE_SAME_ACCESS   As Long = &H2
Public Const INVALID_HANDLE_VALUE    As Long = -1
Public Const INFINITE                As Long = -1&
Public Const PROGRESS_CONTINUE       As Long = 0

Public Enum ErrorNumbers
    EN_OK
    EN_UNABLE_TO_CREATE_DIRECTORY
    EN_UNABLE_TO_COPY_FILE
End Enum

Private Enum MessagesNumbers
    MN_OK
    MN_COPYING_STARTS
    MN_ENUMERATION_FAILED
    MN_ENUMERATION_COMPLETED
    MN_NEW_FOLDER
    MN_NEW_FILE
    MN_FILE_PART
    MN_OPERATION_COMPLETED
    MN_CANCEL
    MN_ERROR
End Enum

Public Type EnumerateData
    nNumberOfFiles              As Currency
    nNumberOfFolders            As Currency
    nDataCountInBytes           As Currency
    nTransferedDataInBytes      As Currency
End Type

Private Type Message
    nCode                       As MessagesNumbers
    lpData                      As Long
    dwDataCount                 As Long
    oNotifyObject               As Long
End Type

Private Type SynchCallData
    hEvent                      As Long
    lpData                      As Long
    dwDataCount                 As Long
    lpRet                       As Long
End Type

Private Type threadData
    bstrSrcPath                 As Long
    bstrDstPath                 As Long
    hCallerThread               As Long
    oNotifyObject               As Long
    pCancelVariable             As Long
End Type

Private Type ThreadData2
    bstrSrcPath                 As String
    bstrDstPath                 As String
    hCallerThread               As Long
    oNotifyObject               As Long
    pCancelVariable             As Long
End Type

Private Type CopyProgressParam
    threadData                  As ThreadData2
    EnumerateData               As EnumerateData
End Type

Private Type OperationProgress
    sFileName                   As Long
    info                        As EnumerateData
End Type

Private Type FILETIME
    dwLowDateTime               As Long
    dwHighDateTime              As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes            As Long
    ftCreationTime              As FILETIME
    ftLastAccessTime            As FILETIME
    ftLastWriteTime             As FILETIME
    nFileSizeHigh               As Long
    nFileSizeLow                As Long
    dwReserved0                 As Long
    dwReserved1                 As Long
    cFileName(MAX_PATH - 1)     As Integer
    cAlternate(13)              As Integer
End Type

Public Declare Function SuspendThread Lib "kernel32" ( _
                        ByVal hThread As Long) As Long
Public Declare Function ResumeThread Lib "kernel32" ( _
                        ByVal hThread As Long) As Long
Public Declare Function CreateEvent Lib "kernel32" _
                        Alias "CreateEventW" ( _
                        ByRef lpEventAttributes As Any, _
                        ByVal bManualReset As Long, _
                        ByVal bInitialState As Long, _
                        ByVal lpName As Long) As Long
Public Declare Function QueueUserAPC Lib "kernel32" ( _
                        ByVal pfnAPC As Long, _
                        ByVal hThread As Long, _
                        ByVal dwData As Long) As Long
Public Declare Function CopyFileEx Lib "kernel32" _
                        Alias "CopyFileExW" ( _
                        ByVal lpExistingFileName As Long, _
                        ByVal lpNewFileName As Long, _
                        ByVal lpProgressRoutine As Long, _
                        ByRef lpData As Any, _
                        ByRef pbCancel As Any, _
                        ByVal dwCopyFlags As Long) As Long
Public Declare Function CreateDirectory Lib "kernel32" _
                        Alias "CreateDirectoryW" ( _
                        ByVal lpPathName As Long, _
                        ByRef lpSecurityAttributes As Any) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" ( _
                        ByVal hHandle As Long, _
                        ByVal dwMilliseconds As Long) As Long

Public Declare Function FindFirstFile Lib "kernel32" _
                        Alias "FindFirstFileW" ( _
                        ByVal lpFileName As Long, _
                        ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32" _
                        Alias "FindNextFileW" ( _
                        ByVal hFindFile As Long, _
                        ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32" ( _
                        ByVal hFindFile As Long) As Long
Public Declare Function GetFullPathName Lib "kernel32" _
                        Alias "GetFullPathNameW" ( _
                        ByVal lpFileName As Long, _
                        ByVal nBufferLength As Long, _
                        ByVal lpBuffer As Long, _
                        ByRef lpFilePart As Long) As Long
Public Declare Function PathIsDirectory Lib "Shlwapi" _
                        Alias "PathIsDirectoryW" ( _
                        ByVal pszPath As Long) As Long
Public Declare Function SysAllocString Lib "oleaut32" ( _
                        ByVal nString As Long) As Long
Public Declare Function SysFreeString Lib "oleaut32" ( _
                        ByVal nString As Long) As Long
Public Declare Function GetProcessHeap Lib "kernel32" () As Long
Public Declare Function HeapAlloc Lib "kernel32" ( _
                        ByVal hHeap As Long, _
                        ByVal dwFlags As Long, _
                        ByVal dwBytes As Long) As Long
Public Declare Function HeapFree Lib "kernel32" ( _
                        ByVal hHeap As Long, _
                        ByVal dwFlags As Long, _
                        ByRef lpMem As Any) As Long
Public Declare Function CloseHandle Lib "kernel32" ( _
                        ByVal hObject As Long) As Long
Public Declare Function DuplicateHandle Lib "kernel32" ( _
                        ByVal hSourceProcessHandle As Long, _
                        ByVal hSourceHandle As Long, _
                        ByVal hTargetProcessHandle As Long, _
                        ByRef lpTargetHandle As Long, _
                        ByVal dwDesiredAccess As Long, _
                        ByVal bInheritHandle As Long, _
                        ByVal dwOptions As Long) As Long
Public Declare Function lstrcmpi Lib "kernel32" _
                        Alias "lstrcmpiW" ( _
                        ByVal lpString1 As Long, _
                        ByVal lpString2 As Long) As Long
Public Declare Function lstrlen Lib "kernel32" _
                        Alias "lstrlenW" ( _
                        ByVal lpString As Long) As Long
Public Declare Function lstrcpy Lib "kernel32" _
                        Alias "lstrcpyW" ( _
                        ByVal lpString1 As Long, _
                        ByVal lpString2 As Long) As Long
Public Declare Function GetCurrentThread Lib "kernel32" () As Long
Public Declare Function VarR8FromUI8 Lib "oleaut32" ( _
                        ByVal UI8L As Long, _
                        ByVal UI8H As Long, _
                        ByRef R8 As Double) As Long
Public Declare Function SetEvent Lib "kernel32" ( _
                        ByVal hEvent As Long) As Long
Public Declare Function SleepEx Lib "kernel32" ( _
                        ByVal dwMilliseconds As Long, _
                        ByVal bAlertable As Long) As Long
'Public Declare Function vbCreateThread Lib "TrickMultithreading" ( _
'                        ByVal lpThreadAttributes As Long, _
'                        ByVal dwStackSize As Long, _
'                        ByVal lpStartAddress As Long, _
'                        ByVal lpParameter As Long, _
'                        ByVal dwCreationFlags As Long, _
'                        ByRef lpThreadId As Long) As Long
'
Public Declare Sub GetMem2 Lib "MSVBVM60.DLL" ( _
                   ByRef pSource As Any, _
                   ByRef pDest As Any)
Public Declare Sub GetMem4 Lib "MSVBVM60.DLL" ( _
                   ByRef pSource As Any, _
                   ByRef pDest As Any)
Public Declare Sub CopyMemory Lib "kernel32" _
                   Alias "RtlMoveMemory" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal Length As Long)
Public Declare Sub vbaObjAddref Lib "MSVBVM60.DLL" _
                   Alias "__vbaObjAddref" ( _
                   ByRef obj As Any)
Public Declare Sub vbaObjSet Lib "MSVBVM60.DLL" _
                   Alias "__vbaObjSet" ( _
                   ByRef obj As Any, _
                   ByRef srcObjPtr As Any)

Public Function CopyFolderInNewThread( _
                ByRef SourcePath As String, _
                ByRef DestinationPath As String, _
                ByVal NotifyObject As ICopyFolderNotify, _
                ByRef Cancel As Long) As Long
    Dim srcPath     As String
    Dim dstPath     As String
    
    srcPath = Space$(MAX_PATH)
    dstPath = srcPath
    
    If GetFullPathName(StrPtr(SourcePath), MAX_PATH, StrPtr(srcPath), 0) = 0 Then
        MsgBox "Invalid source path", vbExclamation
        Exit Function
    End If

    If GetFullPathName(StrPtr(DestinationPath), MAX_PATH, StrPtr(dstPath), 0) = 0 Then
        MsgBox "Invalid destination path", vbExclamation
        Exit Function
    End If
    
    If PathIsDirectory(StrPtr(srcPath)) = 0 Then
        MsgBox "Source path is not directory", vbExclamation
        Exit Function
    End If
    
    If PathIsDirectory(StrPtr(dstPath)) = 0 Then
        MsgBox "Destination path is not directory", vbExclamation
        Exit Function
    End If
    
    dstPath = Left$(dstPath, InStr(1, dstPath, vbNullChar) - 1)
    srcPath = Left$(srcPath, InStr(1, srcPath, vbNullChar) - 1)
    
    If InStr(1, dstPath, srcPath) = 1 Then
        MsgBox "Invalid destination path", vbExclamation
        Exit Function
    End If
    
    ' // Make local parameter
    Dim td      As threadData
    Dim pTd     As Long
    Dim hThread As Long
    
    td.bstrSrcPath = SysAllocString(StrPtr(SourcePath))
    td.bstrDstPath = SysAllocString(StrPtr(DestinationPath))
    td.oNotifyObject = ObjPtr(NotifyObject)
    td.pCancelVariable = VarPtr(Cancel)
    
    ' // Add references
    vbaObjAddref ByVal ObjPtr(NotifyObject)
    
    DuplicateHandle -1, GetCurrentThread(), -1, td.hCallerThread, 0, 0, DUPLICATE_SAME_ACCESS
    
    ' // Alloc memory for data
    pTd = HeapAlloc(GetProcessHeap(), 0, Len(td))
    ' // Copy data
    CopyMemory ByVal pTd, td, Len(td)

    ' // Create thread
    hThread = vbCreateThread(0, 0, AddressOf ThreadProc, pTd, 0, 0)
    
    CopyFolderInNewThread = hThread
    
End Function

' // This procedure is called in caller thread
Private Sub NotifyProc( _
            ByRef msg As Message)
    Dim obj As ICopyFolderNotify
    
    If InIDE Then DoEvents
    
    ' // Set object
    vbaObjSet obj, ByVal msg.oNotifyObject
    
    Select Case msg.nCode
    Case MessagesNumbers.MN_COPYING_STARTS
        
        obj.CopyingStarts
        
    Case MessagesNumbers.MN_ENUMERATION_COMPLETED
        Dim ed  As EnumerateData
        
        CopyMemory ed, ByVal msg.lpData, Len(ed)
        Call obj.EnumerationComplete(ed.nNumberOfFiles, ed.nNumberOfFolders, ed.nDataCountInBytes)
    
    Case MessagesNumbers.MN_ENUMERATION_FAILED
        
        Call obj.EnumerationFailed
        
    Case MessagesNumbers.MN_NEW_FILE
        Dim fileName  As String
        Dim fInfo     As OperationProgress
        
        CopyMemory fInfo, ByVal msg.lpData, Len(fInfo)
        
        fileName = Space$(lstrlen(fInfo.sFileName))
        lstrcpy StrPtr(fileName), fInfo.sFileName
        
        Call obj.NewFileStart(fileName, _
                              fInfo.info.nNumberOfFiles, _
                              fInfo.info.nNumberOfFolders, _
                              fInfo.info.nDataCountInBytes - fInfo.info.nTransferedDataInBytes)
        
    Case MessagesNumbers.MN_NEW_FOLDER
        Dim folderName As String
        Dim dInfo      As OperationProgress
        
        CopyMemory dInfo, ByVal msg.lpData, Len(dInfo)
        
        folderName = Space$(lstrlen(dInfo.sFileName))
        lstrcpy StrPtr(fileName), dInfo.sFileName
        
        Call obj.NewFolderStart(folderName, _
                                dInfo.info.nNumberOfFiles, _
                                dInfo.info.nNumberOfFolders, _
                                dInfo.info.nDataCountInBytes - dInfo.info.nTransferedDataInBytes)
        
    Case MessagesNumbers.MN_FILE_PART
        Dim dat(3) As Currency
        
        CopyMemory dat(0), ByVal msg.lpData, 32
        
        Call obj.CopyProgress(dat(0), dat(1), dat(2), dat(3))
        
    Case MessagesNumbers.MN_CANCEL
    
        Call obj.Cancel
        
    Case MessagesNumbers.MN_ERROR
        Dim sc  As SynchCallData
        Dim en  As ErrorNumbers
        Dim ptr As Long
        Dim str As String
        Dim ret As VbMsgBoxResult
        
        CopyMemory sc, ByVal msg.lpData, Len(sc)
        
        ' // Extract data
        GetMem4 ByVal sc.lpData, en
        GetMem4 ByVal sc.lpData + 4, ptr
        GetMem4 ByVal ptr, ptr
        
        str = Space$(lstrlen(ptr))
        lstrcpy StrPtr(str), ptr
        
        Call obj.ErrorOccurs(str, en, ret)
        
        GetMem4 ret, ByVal sc.lpRet
        
        ' // Resume thread
        SetEvent sc.hEvent
    
    Case MessagesNumbers.MN_OPERATION_COMPLETED
        
        obj.Complete
        
        ' // Release object
        vbaObjSet obj, ByVal 0&
        
    End Select
    
    ' // Unset object
    GetMem4 0&, obj
    
    ' // Free memory
    If msg.dwDataCount Then
        HeapFree GetProcessHeap(), 0, msg.lpData
    End If
    
    HeapFree GetProcessHeap(), 0, VarPtr(msg)
    
End Sub

Private Function ThreadProc( _
                 ByRef td As ThreadData2) As Long
    Dim ed  As EnumerateData
    
    ' // Send notification
    TransferData td, MN_COPYING_STARTS, 0, 0
    
    ' // Get information about files
    If Not EnumerateFiles(td, td.bstrSrcPath, ed) Then
    
        If CheckCancel(td) Then
            TransferData td, MN_CANCEL, 0, 0
        Else
            TransferData td, MN_ENUMERATION_FAILED, 0, 0
        End If
        
        GoTo CleanUp
        
    End If
    
    ' // Send notification
    TransferData td, MN_ENUMERATION_COMPLETED, VarPtr(ed), Len(ed)
    
    ' // Copying
    If Not CopyFolder(td, ed, td.bstrDstPath, td.bstrSrcPath) Then
    
        If CheckCancel(td) Then
            TransferData td, MN_CANCEL, 0, 0
        End If
        
        GoTo CleanUp
        
    End If

CleanUp:
    
    ' // Send notification
    TransferData td, MN_OPERATION_COMPLETED, 0, 0
    
    SysFreeString StrPtr(td.bstrDstPath)
    SysFreeString StrPtr(td.bstrSrcPath)
    HeapFree GetProcessHeap(), 0, VarPtr(td)
    
End Function

' // Send data to main thread
Private Function TransferData( _
                 ByRef td As ThreadData2, _
                 ByVal nCode As MessagesNumbers, _
                 ByVal lpData As Long, _
                 ByVal dwDataCount As Long) As Long
    Dim msg     As Message
    Dim pMsg    As Long
    
    msg.nCode = nCode
    msg.dwDataCount = dwDataCount
    msg.oNotifyObject = td.oNotifyObject
    
    If dwDataCount > 0 And lpData <> 0 Then
        msg.lpData = HeapAlloc(GetProcessHeap(), 0, dwDataCount)
        CopyMemory ByVal msg.lpData, ByVal lpData, dwDataCount
    End If
    
    pMsg = HeapAlloc(GetProcessHeap(), 0, Len(msg))
    CopyMemory ByVal pMsg, msg, Len(msg)
    
    QueueUserAPC AddressOf NotifyProc, td.hCallerThread, pMsg
    
End Function

' // Send error
Private Function SendError( _
                 ByRef td As ThreadData2, _
                 ByVal ErrorNumber As ErrorNumbers, _
                 ByRef fileName As String) As VbMsgBoxResult
    Dim sc  As SynchCallData
    Dim ret As VbMsgBoxResult

    sc.hEvent = CreateEvent(ByVal 0&, 1, 0, 0)
    sc.lpRet = VarPtr(ret)
    sc.lpData = VarPtr(ErrorNumber)
    sc.dwDataCount = 8
    
    TransferData td, MN_ERROR, VarPtr(sc), Len(sc)
    
    ' // Wait response
    If InIDE Then
        SleepEx 0, -1
    Else
        WaitForSingleObject sc.hEvent, INFINITE
    End If
       
    SendError = ret
    
End Function

' // Check if cancel value was set
Private Function CheckCancel( _
                 ByRef td As ThreadData2) As Boolean
    GetMem2 ByVal td.pCancelVariable, CheckCancel
End Function

' // Get information about files and folders
Private Function EnumerateFiles( _
                 ByRef td As ThreadData2, _
                 ByRef strFolder As String, _
                 ByRef ed As EnumerateData) As Boolean
    Dim sMask       As String
    Dim hFind       As Long
    Dim fd          As WIN32_FIND_DATA
    Dim fSize       As Currency
    Dim fileName    As String
    Dim Cancel      As Boolean
    
    sMask = strFolder & "\*"
    
    hFind = FindFirstFile(StrPtr(sMask), fd)
    
    If hFind <> INVALID_HANDLE_VALUE Then
        
        Do
            
            If CheckCancel(td) Then Exit Function
            
            If CBool(lstrcmpi(VarPtr(fd.cFileName(0)), StrPtr("."))) And _
               CBool(lstrcmpi(VarPtr(fd.cFileName(0)), StrPtr(".."))) Then
                
                If fd.dwFileAttributes And vbDirectory Then
                
                    fileName = Space$(lstrlen(VarPtr(fd.cFileName(0))))
                    lstrcpy StrPtr(fileName), VarPtr(fd.cFileName(0))
                
                    ed.nNumberOfFolders = ed.nNumberOfFolders + 0.0001@     ' // +1 to 64 bit number
                    
                    If Not EnumerateFiles(td, strFolder & "\" & fileName, ed) Then
                        Exit Function
                    End If
                    
                Else
                    
                    GetMem4 fd.nFileSizeLow, fSize
                    GetMem4 fd.nFileSizeHigh, ByVal VarPtr(fSize) + 4
                    ed.nDataCountInBytes = ed.nDataCountInBytes + fSize
                    ed.nNumberOfFiles = ed.nNumberOfFiles + 0.0001@         ' // +1 to 64 bit number
                     
                End If
                
            End If
        
        Loop While FindNextFile(hFind, fd)
        
        FindClose hFind
    
    Else:   Exit Function
    End If
    
    EnumerateFiles = True
    
End Function

Private Function CopyFolder( _
                 ByRef td As ThreadData2, _
                 ByRef ed As EnumerateData, _
                 ByRef strDstPath As String, _
                 ByRef strSrcPath As String) As Boolean
    Dim sMask       As String
    Dim hFind       As Long
    Dim fd          As WIN32_FIND_DATA
    Dim fileName    As String
    
    sMask = strSrcPath & "\*"
    
    hFind = FindFirstFile(StrPtr(sMask), fd)
    
    If hFind <> INVALID_HANDLE_VALUE Then
        
        Do
            
            If CheckCancel(td) Then Exit Function
            
            If CBool(lstrcmpi(VarPtr(fd.cFileName(0)), StrPtr("."))) And _
               CBool(lstrcmpi(VarPtr(fd.cFileName(0)), StrPtr(".."))) Then
                
                Dim info    As OperationProgress
                
                fileName = Space$(lstrlen(VarPtr(fd.cFileName(0))))
                lstrcpy StrPtr(fileName), VarPtr(fd.cFileName(0))
                
                
                If fd.dwFileAttributes And vbDirectory Then
                    
                    ' // Decrement remain folders
                    ed.nNumberOfFolders = ed.nNumberOfFolders - 0.0001@
                    
                    info.sFileName = SysAllocString(StrPtr(fileName))
                    info.info = ed
                    
                    ' // Send notification
                    TransferData td, MN_NEW_FOLDER, VarPtr(info), Len(info)
                    
                    Do
                        If CreateDirectory(StrPtr(strDstPath & "\" & fileName), ByVal 0&) = 0 Then
                            Select Case SendError(td, EN_UNABLE_TO_CREATE_DIRECTORY, fileName)
                            Case VbMsgBoxResult.vbIgnore
                                Dim ed2 As EnumerateData
                                
                                ' // Skip all files in folder
                                EnumerateFiles td, strSrcPath & "\" & fileName, ed
                                ed.nDataCountInBytes = ed.nDataCountInBytes - ed2.nDataCountInBytes
                                ed.nNumberOfFiles = ed.nNumberOfFiles - ed2.nNumberOfFiles
                                ed.nNumberOfFolders = ed.nNumberOfFolders - ed2.nNumberOfFolders - 0.0001@
                                
                                GoTo continue
                                
                            Case VbMsgBoxResult.vbRetry
                            Case Else
                                Exit Function
                            End Select
                        Else: Exit Do
                        End If
                    Loop
                    
                    If Not CopyFolder(td, ed, strDstPath & "\" & fileName, strSrcPath & "\" & fileName) Then
                        Exit Function
                    End If
                    
                Else
                
                    Dim param   As CopyProgressParam
                    Dim fSize   As Currency
                    
                    ' // Decrement remain files
                    ed.nNumberOfFiles = ed.nNumberOfFiles - 0.0001@
                    GetMem4 fd.nFileSizeLow, fSize
                    GetMem4 fd.nFileSizeHigh, ByVal VarPtr(fSize) + 4

                    info.sFileName = SysAllocString(StrPtr(fileName))
                    info.info = ed
                
                    ' // Send notification
                    TransferData td, MN_NEW_FILE, VarPtr(info), Len(info)

                    param.threadData = td
                    param.EnumerateData = ed
                    
                    Do
                        If CopyFileEx(StrPtr(strSrcPath & "\" & fileName), _
                                      StrPtr(strDstPath & "\" & fileName), _
                                      AddressOf CopyProgressRoutine, param, _
                                      ByVal td.pCancelVariable, 0) = 0 Then
                                
                            If CheckCancel(td) Then Exit Function
                            
                            Select Case SendError(td, EN_UNABLE_TO_COPY_FILE, fileName)
                            Case VbMsgBoxResult.vbIgnore
                                Exit Do
                            Case VbMsgBoxResult.vbRetry
                            Case Else
                                Exit Function
                            End Select
                            
                        Else: Exit Do
                        End If
                        
                    Loop
                    
                    ed.nTransferedDataInBytes = ed.nTransferedDataInBytes + fSize
                    
                End If
                
            End If
continue:
        
        Loop While FindNextFile(hFind, fd)
        
        FindClose hFind
    
    Else:   Exit Function
    End If
    
    CopyFolder = True
    
End Function

Private Function CopyProgressRoutine( _
                 ByVal TotalFileSize As Currency, _
                 ByVal TotalBytesTransferred As Currency, _
                 ByVal StreamSize As Currency, _
                 ByVal StreamBytesTransferred As Currency, _
                 ByVal dwStreamNumber As Long, _
                 ByVal dwCallbackReason As Long, _
                 ByVal hSourceFile As Long, _
                 ByVal hDestinationFile As Long, _
                 ByRef cp As CopyProgressParam) As Long
    Dim param(3) As Currency
    
    If InIDE Then
        SleepEx 0, -1
    End If
    
    param(0) = TotalFileSize
    param(1) = TotalBytesTransferred
    param(2) = cp.EnumerateData.nTransferedDataInBytes + TotalBytesTransferred
    param(3) = cp.EnumerateData.nDataCountInBytes
    
    ' // Send notification
    TransferData cp.threadData, MN_FILE_PART, VarPtr(param(0)), 32
    
    CopyProgressRoutine = PROGRESS_CONTINUE
    
End Function

Public Function InIDE() As Boolean

    Debug.Assert MakeTrue(InIDE)
    
End Function

Private Function MakeTrue( _
                 ByRef val As Boolean) As Boolean
    val = True
    MakeTrue = True
End Function

